#pragma once

#include <list>

typedef struct TCacheString {
	TCHAR securityString[0x10];
	TCHAR hash[0x40];
	DWORD used;
	DWORD deleted;
	DWORD offset;
} CacheString, *PCacheString;

class CredentialCache
{
public:
	static CredentialCache* GetCacheForUser(LPCTSTR username);
	static BOOL LocalUserExists(LPCTSTR username);
	~CredentialCache(void);
	LPCTSTR GetSecurityString(BOOL getNew=TRUE);
	BOOL Authenticate(LPCTSTR secString, LPCTSTR password, LPCTSTR otc);
	void StoreCredentials(PCacheString* newStrings, DWORD cString);

private:
	CredentialCache(LPCTSTR username);
	void LoadStrings();
	static void CheckCacheFolder();
	static LPTSTR CacheFileForUser(LPCTSTR username);

	DWORD lockoutCount;
	int failureCount;
	LPTSTR m_Username;
	LPCTSTR m_Pin;
	LPTSTR m_Password;
	LPTSTR m_CacheFile;
	std::list<PCacheString> m_CachedStrings;
	std::list<PCacheString> m_UsedStrings;
};

extern LPTSTR CreateNewSecurityString(void);