// Crypto.h: interface for the CCrypto class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CRYPTO_H__564701BE_CAD0_11D5_8227_00D0B7E1CE66__INCLUDED_)
#define AFX_CRYPTO_H__564701BE_CAD0_11D5_8227_00D0B7E1CE66__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <wincrypt.h>

#ifndef boolean
#define boolean BOOL
#endif

class CCrypto  
{
public:
	BOOL SetPublicKey(BYTE* PublicKey, DWORD PublicKeyLen);
	DWORD dwSignatureLength;
	BYTE* bySignature;
	boolean SignValidate(BYTE* byBuffer, DWORD dwBufferLen, boolean bSign);
	BYTE* Hash(BYTE* byBuffer, DWORD dwBufferLen, DWORD* dwHashLen, ALG_ID Algid);
	DWORD dwSessionLength;
	BYTE* bySession;
	boolean EncryptDecryptKeyPair(BYTE* byBuffer, DWORD dwBufferLen, boolean bEncrypt);
	boolean EncryptDecrypt(BYTE* byBuffer, DWORD dwBufferLen, BYTE* byKey, DWORD dwKeyLen, boolean bEncrypt);
	BYTE* RandomKey(DWORD dwLength);
	boolean ImportKeyPair(const char* strPassword, boolean bExchangeKeyPair);
	boolean SessionKeyFromPassword(BYTE* byKey, DWORD dwLength);
	BYTE* byPublicKey;
	DWORD dwPublicKeyLength;
	BYTE* byPrivateKey;
	DWORD dwPrivateKeyLength;	
	boolean ExportKeyPair(const char* strPassword);
//	boolean GenerateKeyPair(boolean bUseExchangeKeyPair);
	void SessionEnd();
	boolean SessionStart();
	CCrypto();
	virtual ~CCrypto();

private:
	long lType;
	HCRYPTKEY  hSessionKey;
	HCRYPTKEY  hKeyPair;
	HCRYPTPROV hCryptProv;
};

#endif // !defined(AFX_CRYPTO_H__564701BE_CAD0_11D5_8227_00D0B7E1CE66__INCLUDED_)
