#pragma once
#pragma comment(lib, "winhttp.lib")

#include <winhttp.h>

class HttpSocket
{
public:
	HttpSocket(void);
	~HttpSocket(void);
	LPWSTR GetPage(LPCWSTR url, BOOL Post = TRUE, LPCWSTR PostData = NULL, int PostDataLength = -1); //get a page, if post is false, HTTP GET is used othervise HTTP POST is used. if PostDataLength is -1 the data must be NULL terminated...	
	LPSTR GetPageBytes(LPCWSTR url, BOOL Post = FALSE, LPCWSTR PostData = NULL, int PostDataLength = -1, int *byteCount = NULL); //get a page, if post is false, HTTP GET is used othervise HTTP POST is used. if PostDataLength is -1 the data must be NULL terminated...	
	int GetPageStatusCode(); //get the HTTP statuscode for the last received page
	void SetSecure(BOOL sec) { secure = sec; }
	void SetAllowSelfCert(BOOL allow) { allowSelfCert = allow; }

private:
	BOOL PostUrl(LPCWSTR url, LPCSTR PostData, int PostDataLength = -1); //open a page using http post	
	BOOL GetFromUrl(LPCWSTR url); //open a page using http get
	BOOL OpenUrl(LPCWSTR url, LPCWSTR verb, LPCSTR PostData, int PostDataLength = -1); //open a page
	LPWSTR GetHeaders(); //return a pointer to the headers from the current url

	HINTERNET hIO, hIS, hCO;
	long cDataSize;
	LPWSTR Headers; //the internal headerbuffer
	BOOL secure;
	BOOL allowSelfCert;
};
