#include "stdafx.h"
#include "Logging.h"

#define PROVIDER_NAME L"PINsafeLogin"

void LogMessage(WORD type, WORD eventId, LPCWSTR fmt, va_list args) {
	HANDLE hEventLog = RegisterEventSourceW(NULL, PROVIDER_NAME);
	LPCWSTR msgs[1];
	LPWSTR msg = (LPWSTR)CoTaskMemAlloc(0x100 * sizeof(TCHAR));
	vswprintf_s(msg, 0x100, fmt, args);
	msgs[0] = msg;
	ReportEventW(hEventLog, type, LOGIN_CATEGORY, eventId, NULL, 1, 0, msgs, NULL);
	CoTaskMemFree(msg);
	DeregisterEventSource(hEventLog);
}

void LogInfo(LPCWSTR msg, ...) {
	va_list args;
	va_start(args, msg);
	LogMessage(EVENTLOG_INFORMATION_TYPE, MSG_INFO, msg, args);
	va_end(args);
}

void LogError(LPCWSTR msg, ...) {
	va_list args;
	va_start(args, msg);
	LogMessage(EVENTLOG_ERROR_TYPE, MSG_ERROR, msg, args);
	va_end(args);
}
