// PINsafe Login provider message file.
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//
#define FACILITY_LOGIN                   0x1


//
// Define the severity codes
//
#define STATUS_SEVERITY_INFORMATIONAL    0x1
#define STATUS_SEVERITY_ERROR            0x3


//
// MessageId: LOGIN_CATEGORY
//
// MessageText:
//
//  PINsafe Login
//
#define LOGIN_CATEGORY                   ((WORD)0x00000001L)

//
// MessageId: MSG_INFO
//
// MessageText:
//
//  PINsafe Login Provider: %1
//
//#define MSG_INFO                         ((WORD)0x40010100L)
#define MSG_INFO                         ((WORD)0x100L)

//
// MessageId: MSG_ERROR
//
// MessageText:
//
//  PINsafe Login Provider Error: %1
//
//#define MSG_ERROR                        ((WORD)0xC0010101L)
#define MSG_ERROR                        ((WORD)0x101L)

