#pragma once

typedef enum {
	PINsafeLoginAlways,
	PINsafeLoginRemote,
	PINsafeLoginDisabled
} PINsafeLoginSelect;

typedef enum {
	PINsafeLocalNever,
	PINsafeLocalFallback,
	PINsafeLocalAlways
} PINsafeLocalSelect;

class RegSettings
{
public:
	static RegSettings* GetSettings();
	~RegSettings(void);

	LPCWSTR GetServer() { return server; }
	LPCWSTR GetPort() { return port; }
	LPCWSTR GetContext() { return context; }
	LPCWSTR GetSecret() { return secret; }
	BOOL IsSecure() { return secure; }
	BOOL LoginLocal() { return selectLogin == PINsafeLoginAlways; }
	BOOL LoginRemote() { return selectLogin != PINsafeLoginDisabled; }
	BOOL LoginRemoteOnly() { return selectLogin == PINsafeLoginRemote; }
	BOOL LoginDisabled() { return selectLogin == PINsafeLoginDisabled; }
	BOOL ShowGetImage() { return showGetImage; }
	BOOL ShowRequestString() { return showRequestString; }
	BOOL AllowDefaultLogin() { return allowDefaultLogin; }
	BOOL AllowSelfCertification() { return allowSelfCert; }
	BOOL DisableFilter() { return disableFilter; }
	DWORD GetCachedStringCount() { return cachedStringCount; }
	DWORD GetSessionTimeout() { return sessionTimeout; }
	DWORD GetCacheLowCount() { return cacheLowCount; }
	LPCWSTR GetFontsFolder() { return fontsFolder; }
	LPCWSTR GetBackgroundsFolder() { return backgroundsFolder; }
	DWORD GetLockoutCount() { return lockoutCount; }
	BOOL UseLocalAuth() { return useLocal == PINsafeLocalAlways; }
	BOOL AllowLocalAuth() { return useLocal != PINsafeLocalNever; }
	BOOL IgnoreDomain() { return ignoreDomain; }
	BOOL AllowUnknownUsers() { return allowUnknownUsers; }
	LPCWSTR GetResourceDll() { return resourceDll; }

private:
	RegSettings(void);
	LPWSTR server;
	LPWSTR port;
	LPWSTR context;
	BOOL secure;
	LPWSTR secret;
	BOOL showGetImage;
	BOOL showRequestString;
	BOOL allowDefaultLogin;
	PINsafeLoginSelect selectLogin;
	BOOL allowSelfCert;
	BOOL disableFilter;
	BOOL ignoreDomain;
	BOOL allowUnknownUsers;
	DWORD cachedStringCount;
	DWORD sessionTimeout;
	DWORD cacheLowCount;
	LPWSTR fontsFolder;
	LPWSTR backgroundsFolder;
	LPWSTR resourceDll;
	DWORD lockoutCount;
	PINsafeLocalSelect useLocal;
};

