#pragma once

#include "TuringGenerator.h"

class PINsafeLoginCredential;

// TuringThread

class TuringThread : public CWinThread
{
	DECLARE_DYNCREATE(TuringThread)

protected:
	TuringThread();
	virtual ~TuringThread();

public:
	void Terminate();
	void SetCredential(PINsafeLoginCredential* cred) { _pCredential = cred; }
	void SetParent(HWND hParent) { _hParentWindow = hParent; }
	void SetImage(IPicture* turing);
	void SetLocalImage(CTuringGenerator* turing, LPCTSTR username, HINSTANCE hRes);
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual BOOL PreTranslateMessage(MSG *pMsg);
	DWORD Pause();
	DWORD Resume();
	BOOL Visible();

private:
	HWND	_hParentWindow;
	HWND	_hTURing_Dialog;
	HWND	_hTURing_Image;
	HBITMAP _hTURing_Bitmap;
	BOOL	_terminated;
	BOOL	_suppressImage;
	// Settings for displaying a remote image
	BOOL	_displayRemote;
	IPicture* _turingRemote;
	void DisplayImage();
	// Settings for displaying a local image
	BOOL _displayLocal;
	CTuringGenerator* _turingLocal;
	LPCTSTR _localUser;
	HINSTANCE _localResource;
	void DisplayLocalImage();
	PINsafeLoginCredential* _pCredential;

protected:
	DECLARE_MESSAGE_MAP()
};


